searchNodes=[{"doc":"A blazing fast JSON parser and generator in pure Elixir.","ref":"Jason.html","title":"Jason","type":"module"},{"doc":"Parses a JSON value from input iodata. Options :keys - controls how keys in objects are decoded. Possible values are: :strings (default) - decodes keys as binary strings, :atoms - keys are converted to atoms using String.to_atom/1, :atoms! - keys are converted to atoms using String.to_existing_atom/1, custom decoder - additionally a function accepting a string and returning a key is accepted. :strings - controls how strings (including keys) are decoded. Possible values are: :reference (default) - when possible tries to create a sub-binary into the original :copy - always copies the strings. This option is especially useful when parts of the decoded data will be stored for a long time (in ets or some process) to avoid keeping the reference to the original data. Decoding keys to atoms The :atoms option uses the String.to_atom/1 call that can create atoms at runtime. Since the atoms are not garbage collected, this can pose a DoS attack vector when used on user-controlled data. Examples iex&gt; Jason.decode(&quot;{}&quot;) {:ok, %{}} iex&gt; Jason.decode(&quot;invalid&quot;) {:error, %Jason.DecodeError{data: &quot;invalid&quot;, position: 0, token: nil}}","ref":"Jason.html#decode/2","title":"Jason.decode/2","type":"function"},{"doc":"Parses a JSON value from input iodata. Similar to decode/2 except it will unwrap the error tuple and raise in case of errors. Examples iex&gt; Jason.decode!(&quot;{}&quot;) %{} iex&gt; Jason.decode!(&quot;invalid&quot;) ** (Jason.DecodeError) unexpected byte at position 0: 0x69 (&#39;i&#39;)","ref":"Jason.html#decode!/2","title":"Jason.decode!/2","type":"function"},{"doc":"Generates JSON corresponding to input. The generation is controlled by the Jason.Encoder protocol, please refer to the module to read more on how to define the protocol for custom data types. Options :escape - controls how strings are encoded. Possible values are: :json (default) - the regular JSON escaping as defined by RFC 7159. :javascript_safe - additionally escapes the LINE SEPARATOR (U+2028) and PARAGRAPH SEPARATOR (U+2029) characters to make the produced JSON valid JavaScript. :html_safe - similar to :javascript_safe, but also escapes the / character to prevent XSS. :unicode_safe - escapes all non-ascii characters. :maps - controls how maps are encoded. Possible values are: :strict - checks the encoded map for duplicate keys and raises if they appear. For example %{:foo =&gt; 1, &quot;foo&quot; =&gt; 2} would be rejected, since both keys would be encoded to the string &quot;foo&quot;. :naive (default) - does not perform the check. :pretty - controls pretty printing of the output. Possible values are: true to pretty print with default configuration a keyword of options as specified by Jason.Formatter.pretty_print/2. Examples iex&gt; Jason.encode(%{a: 1}) {:ok, ~S|{&quot;a&quot;:1}|} iex&gt; Jason.encode(&quot;\\xFF&quot;) {:error, %Jason.EncodeError{message: &quot;invalid byte 0xFF in &lt;&lt;255&gt;&gt;&quot;}}","ref":"Jason.html#encode/2","title":"Jason.encode/2","type":"function"},{"doc":"Generates JSON corresponding to input. Similar to encode/1 except it will unwrap the error tuple and raise in case of errors. Examples iex&gt; Jason.encode!(%{a: 1}) ~S|{&quot;a&quot;:1}| iex&gt; Jason.encode!(&quot;\\xFF&quot;) ** (Jason.EncodeError) invalid byte 0xFF in &lt;&lt;255&gt;&gt;","ref":"Jason.html#encode!/2","title":"Jason.encode!/2","type":"function"},{"doc":"Generates JSON corresponding to input and returns iodata. This function should be preferred to encode/2, if the generated JSON will be handed over to one of the IO functions or sent over the socket. The Erlang runtime is able to leverage vectorised writes and avoid allocating a continuous buffer for the whole resulting string, lowering memory use and increasing performance. Examples iex&gt; {:ok, iodata} = Jason.encode_to_iodata(%{a: 1}) iex&gt; IO.iodata_to_binary(iodata) ~S|{&quot;a&quot;:1}| iex&gt; Jason.encode_to_iodata(&quot;\\xFF&quot;) {:error, %Jason.EncodeError{message: &quot;invalid byte 0xFF in &lt;&lt;255&gt;&gt;&quot;}}","ref":"Jason.html#encode_to_iodata/2","title":"Jason.encode_to_iodata/2","type":"function"},{"doc":"Generates JSON corresponding to input and returns iodata. Similar to encode_to_iodata/1 except it will unwrap the error tuple and raise in case of errors. Examples iex&gt; iodata = Jason.encode_to_iodata!(%{a: 1}) iex&gt; IO.iodata_to_binary(iodata) ~S|{&quot;a&quot;:1}| iex&gt; Jason.encode_to_iodata!(&quot;\\xFF&quot;) ** (Jason.EncodeError) invalid byte 0xFF in &lt;&lt;255&gt;&gt;","ref":"Jason.html#encode_to_iodata!/2","title":"Jason.encode_to_iodata!/2","type":"function"},{"doc":"","ref":"Jason.html#t:decode_opt/0","title":"Jason.decode_opt/0","type":"type"},{"doc":"","ref":"Jason.html#t:encode_opt/0","title":"Jason.encode_opt/0","type":"type"},{"doc":"","ref":"Jason.html#t:escape/0","title":"Jason.escape/0","type":"type"},{"doc":"","ref":"Jason.html#t:keys/0","title":"Jason.keys/0","type":"type"},{"doc":"","ref":"Jason.html#t:maps/0","title":"Jason.maps/0","type":"type"},{"doc":"","ref":"Jason.html#t:strings/0","title":"Jason.strings/0","type":"type"},{"doc":"Utilities for encoding elixir values to JSON.","ref":"Jason.Encode.html","title":"Jason.Encode","type":"module"},{"doc":"","ref":"Jason.Encode.html#atom/2","title":"Jason.Encode.atom/2","type":"function"},{"doc":"","ref":"Jason.Encode.html#float/1","title":"Jason.Encode.float/1","type":"function"},{"doc":"","ref":"Jason.Encode.html#integer/1","title":"Jason.Encode.integer/1","type":"function"},{"doc":"","ref":"Jason.Encode.html#keyword/2","title":"Jason.Encode.keyword/2","type":"function"},{"doc":"","ref":"Jason.Encode.html#list/2","title":"Jason.Encode.list/2","type":"function"},{"doc":"","ref":"Jason.Encode.html#map/2","title":"Jason.Encode.map/2","type":"function"},{"doc":"","ref":"Jason.Encode.html#string/2","title":"Jason.Encode.string/2","type":"function"},{"doc":"","ref":"Jason.Encode.html#struct/2","title":"Jason.Encode.struct/2","type":"function"},{"doc":"Equivalent to calling the Jason.Encoder.encode/2 protocol function. Slightly more efficient for built-in types because of the internal dispatching.","ref":"Jason.Encode.html#value/2","title":"Jason.Encode.value/2","type":"function"},{"doc":"","ref":"Jason.Encode.html#t:opts/0","title":"Jason.Encode.opts/0","type":"opaque"},{"doc":"Protocol controlling how a value is encoded to JSON. Deriving The protocol allows leveraging the Elixir&#39;s @derive feature to simplify protocol implementation in trivial cases. Accepted options are: :only - encodes only values of specified keys. :except - encodes all struct fields except specified keys. By default all keys except the :__struct__ key are encoded. Example Let&#39;s assume a presence of the following struct: defmodule Test do defstruct [:foo, :bar, :baz] end If we were to call @derive Jason.Encoder just before defstruct, an implementation similar to the following implementation would be generated: defimpl Jason.Encoder, for: Test do def encode(value, opts) do Jason.Encode.map(Map.take(value, [:foo, :bar, :baz]), opts) end end If we called @derive {Jason.Encoder, only: [:foo]}, an implementation similar to the following implementation would be generated: defimpl Jason.Encoder, for: Test do def encode(value, opts) do Jason.Encode.map(Map.take(value, [:foo]), opts) end end If we called @derive {Jason.Encoder, except: [:foo]}, an implementation similar to the following implementation would be generated: defimpl Jason.Encoder, for: Test do def encode(value, opts) do Jason.Encode.map(Map.take(value, [:bar, :baz]), opts) end end The actually generated implementations are more efficient computing some data during compilation similar to the macros from the Jason.Helpers module. Explicit implementation If you wish to implement the protocol fully yourself, it is advised to use functions from the Jason.Encode module to do the actual iodata generation - they are highly optimized and verified to always produce valid JSON.","ref":"Jason.Encoder.html","title":"Jason.Encoder","type":"protocol"},{"doc":"Encodes value to JSON. The argument opts is opaque - it can be passed to various functions in Jason.Encode (or to the protocol function itself) for encoding values to JSON.","ref":"Jason.Encoder.html#encode/2","title":"Jason.Encoder.encode/2","type":"function"},{"doc":"","ref":"Jason.Encoder.html#t:opts/0","title":"Jason.Encoder.opts/0","type":"type"},{"doc":"","ref":"Jason.Encoder.html#t:t/0","title":"Jason.Encoder.t/0","type":"type"},{"doc":"Pretty-printing and minimizing functions for JSON-encoded data. Input is required to be in an 8-bit-wide encoding such as UTF-8 or Latin-1 in iodata/0 format. Input must ve valid JSON, invalid JSON may produce unexpected results or errors.","ref":"Jason.Formatter.html","title":"Jason.Formatter","type":"module"},{"doc":"Minimizes JSON-encoded input. input may contain multiple JSON objects or arrays, optionally separated by whitespace (e.g., one object per line). Minimized output will contain one object per line. No trailing newline is emitted. Options :record_separator - controls the string used as newline (default: &quot;\\n&quot;). Examples iex&gt; Jason.Formatter.minimize(~s|{ &quot;a&quot; : &quot;b&quot; , &quot;c&quot;: \\n\\n 2}|) ~s|{&quot;a&quot;:&quot;b&quot;,&quot;c&quot;:2}|","ref":"Jason.Formatter.html#minimize/2","title":"Jason.Formatter.minimize/2","type":"function"},{"doc":"Minimizes JSON-encoded input and returns iodata. This function should be preferred to minimize/2, if the minimized JSON will be handed over to one of the IO functions or sent over the socket. The Erlang runtime is able to leverage vectorised writes and avoid allocating a continuous buffer for the whole resulting string, lowering memory use and increasing performance.","ref":"Jason.Formatter.html#minimize_to_iodata/2","title":"Jason.Formatter.minimize_to_iodata/2","type":"function"},{"doc":"Pretty-prints JSON-encoded input. input may contain multiple JSON objects or arrays, optionally separated by whitespace (e.g., one object per line). Objects in output will be separated by newlines. No trailing newline is emitted. Options :indent - used for nested objects and arrays (default: two spaces - &quot; &quot;); :line_separator - used in nested objects (default: &quot;\\n&quot;); :record_separator - separates root-level objects and arrays (default is the value for :line_separator option); :after_colon - printed after a colon inside objects (default: one space - &quot; &quot;). Examples iex&gt; Jason.Formatter.pretty_print(~s|{&quot;a&quot;:{&quot;b&quot;: [1, 2]}}|) ~s|{ &quot;a&quot;: { &quot;b&quot;: [ 1, 2 ] } }|","ref":"Jason.Formatter.html#pretty_print/2","title":"Jason.Formatter.pretty_print/2","type":"function"},{"doc":"Pretty-prints JSON-encoded input and returns iodata. This function should be preferred to pretty_print/2, if the pretty-printed JSON will be handed over to one of the IO functions or sent over the socket. The Erlang runtime is able to leverage vectorised writes and avoid allocating a continuous buffer for the whole resulting string, lowering memory use and increasing performance.","ref":"Jason.Formatter.html#pretty_print_to_iodata/2","title":"Jason.Formatter.pretty_print_to_iodata/2","type":"function"},{"doc":"","ref":"Jason.Formatter.html#t:opts/0","title":"Jason.Formatter.opts/0","type":"type"},{"doc":"","ref":"Jason.Fragment.html","title":"Jason.Fragment","type":"module"},{"doc":"","ref":"Jason.Fragment.html#new/1","title":"Jason.Fragment.new/1","type":"function"},{"doc":"Provides macro facilities for partial compile-time encoding of JSON.","ref":"Jason.Helpers.html","title":"Jason.Helpers","type":"module"},{"doc":"Encodes a JSON map from a compile-time keyword. Encodes the keys at compile time and strives to create as flat iodata structure as possible to achieve maximum efficiency. Does encoding right at the call site, but returns an %Jason.Fragment{} struct that needs to be passed to one of the &quot;main&quot; encoding functions - for example Jason.encode/2 for final encoding into JSON - this makes it completely transparent for most uses. Only allows keys that do not require escaping in any of the supported encoding modes. This means only ASCII characters from the range 0x1F..0x7F excluding &#39;\\&#39;, &#39;/&#39; and &#39;&quot;&#39; are allowed - this also excludes all control characters like newlines. Preserves the order of the keys. Example iex&gt; fragment = json_map(foo: 1, bar: 2) iex&gt; Jason.encode!(fragment) &quot;{\\&quot;foo\\&quot;:1,\\&quot;bar\\&quot;:2}&quot;","ref":"Jason.Helpers.html#json_map/1","title":"Jason.Helpers.json_map/1","type":"macro"},{"doc":"Encodes a JSON map from a variable containing a map and a compile-time list of keys. It is equivalent to calling Map.take/2 before encoding. Otherwise works similar to json_map/2. Example iex&gt; map = %{a: 1, b: 2, c: 3} iex&gt; fragment = json_map_take(map, [:c, :b]) iex&gt; Jason.encode!(fragment) &quot;{\\&quot;c\\&quot;:3,\\&quot;b\\&quot;:2}&quot;","ref":"Jason.Helpers.html#json_map_take/2","title":"Jason.Helpers.json_map_take/2","type":"macro"},{"doc":"","ref":"Jason.DecodeError.html","title":"Jason.DecodeError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Jason.DecodeError.html#message/1","title":"Jason.DecodeError.message/1","type":"function"},{"doc":"","ref":"Jason.DecodeError.html#t:t/0","title":"Jason.DecodeError.t/0","type":"type"},{"doc":"","ref":"Jason.EncodeError.html","title":"Jason.EncodeError","type":"exception"},{"doc":"","ref":"Jason.EncodeError.html#new/1","title":"Jason.EncodeError.new/1","type":"function"},{"doc":"","ref":"Jason.EncodeError.html#t:t/0","title":"Jason.EncodeError.t/0","type":"type"},{"doc":"Jason A blazing fast JSON parser and generator in pure Elixir. The parser and generator are at least twice as fast as other Elixir/Erlang libraries (most notably Poison). The performance is comparable to jiffy, which is implemented in C as a NIF. Jason is usually only twice as slow. Both parser and generator fully conform to RFC 8259 and ECMA 404 standards. The parser is tested using JSONTestSuite.","ref":"readme.html","title":"Jason","type":"extras"},{"doc":"The package can be installed by adding jason to your list of dependencies in mix.exs: def deps do [{:jason, &quot;~&gt; 1.2&quot;}] end","ref":"readme.html#installation","title":"Jason - Installation","type":"extras"},{"doc":"iex(1)&gt; Jason.encode!(%{&quot;age&quot; =&gt; 44, &quot;name&quot; =&gt; &quot;Steve Irwin&quot;, &quot;nationality&quot; =&gt; &quot;Australian&quot;}) &quot;{\\&quot;age\\&quot;:44,\\&quot;name\\&quot;:\\&quot;Steve Irwin\\&quot;,\\&quot;nationality\\&quot;:\\&quot;Australian\\&quot;}&quot; iex(2)&gt; Jason.decode!(~s({&quot;age&quot;:44,&quot;name&quot;:&quot;Steve Irwin&quot;,&quot;nationality&quot;:&quot;Australian&quot;})) %{&quot;age&quot; =&gt; 44, &quot;name&quot; =&gt; &quot;Steve Irwin&quot;, &quot;nationality&quot; =&gt; &quot;Australian&quot;} Full documentation can be found at https://hexdocs.pm/jason.","ref":"readme.html#basic-usage","title":"Jason - Basic Usage","type":"extras"},{"doc":"Postgrex Versions starting at 0.14.0 use Jason by default. For earlier versions, please refer to previous versions of this document. Ecto Versions starting at 3.0.0 use Jason by default. For earlier versions, please refer to previous versions of this document. Plug (and Phoenix) Phoenix starting at 1.4.0 uses Jason by default. For earlier versions, please refer to previous versions of this document. Absinthe You need to pass the :json_codec option to Absinthe.Plug # When called directly: plug Absinthe.Plug, schema: MyApp.Schema, json_codec: Jason # When used in phoenix router: forward &quot;/api&quot;, to: Absinthe.Plug, init_opts: [schema: MyApp.Schema, json_codec: Jason]","ref":"readme.html#use-with-other-libraries","title":"Jason - Use with other libraries","type":"extras"},{"doc":"Detailed benchmarks (including memory measurements): https://gist.github.com/michalmuskala/4d64a5a7696ca84ac7c169a0206640d5 HTML reports for the benchmark (only performance measurements): http://michal.muskala.eu/jason/decode.html and http://michal.muskala.eu/jason/encode.html Running Benchmarks against most popular Elixir &amp; Erlang json libraries can be executed after going into the bench/ folder and then executing mix bench.encode and mix bench.decode. A HTML report of the benchmarks (after their execution) can be found in bench/output/encode.html and bench/output/decode.html respectively.","ref":"readme.html#benchmarks","title":"Jason - Benchmarks","type":"extras"},{"doc":"Jason has a couple feature differences compared to Poison. Jason follows the JSON spec more strictly, for example it does not allow unescaped newline characters in JSON strings - e.g. &quot;\\&quot;\\n\\&quot;&quot; will produce a decoding error. no support for decoding into data structures (the as: option). no built-in encoders for MapSet, Range and Stream. no support for encoding arbitrary structs - explicit implementation of the Jason.Encoder protocol is always required. different pretty-printing customisation options (default pretty: true works the same) If you require encoders for any of the unsupported collection types, I suggest adding the needed implementations directly to your project: defimpl Jason.Encoder, for: [MapSet, Range, Stream] do def encode(struct, opts) do Jason.Encode.list(Enum.to_list(struct), opts) end end If you need to encode some struct that does not implement the protocol, if you own the struct, you can derive the implementation specifying which fields should be encoded to JSON: @derive {Jason.Encoder, only: [....]} defstruct # ... It is also possible to encode all fields, although this should be used carefully to avoid accidentally leaking private information when new fields are added: @derive Jason.Encoder defstruct # ... Finally, if you don&#39;t own the struct you want to encode to JSON, you may use Protocol.derive/3 placed outside of any module: Protocol.derive(Jason.Encoder, NameOfTheStruct, only: [...]) Protocol.derive(Jason.Encoder, NameOfTheStruct)","ref":"readme.html#differences-to-poison","title":"Jason - Differences to Poison","type":"extras"},{"doc":"Jason is released under the Apache License 2.0 - see the LICENSE file. Some elements of tests and benchmarks have their origins in the Poison library and were initially licensed under CC0-1.0.","ref":"readme.html#license","title":"Jason - License","type":"extras"}]